<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cv;
	protected $obj_notify;
	protected $obj_upload;
	protected $obj_bnihashing;
	protected $obj_registrasi;
	// variable definition
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'praktik');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		$this->obj_bnihashing = $this->obj_ctrl->LoadLibrary('Bnihashing');	
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'virtual':
				self::InsertVirtual();
				break;
			case 'update':
				self::UpdateTempatKerja();
				break;
			case 'delete':
				self::DeleteTempatKerja();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// operation
	private function InsertVirtual(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		$params_userid = array($this->arr_params['user_id']);
		$result = $this->obj_cv->GetIdentitasPribadiByIdPersonVirtual($params_userid);
		//print_r($result['email']);exit;
		// required -------------------------------------------
		
		if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing -----------------------------------------------------
		if(empty($err)){
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = $MaxId['id']+ 1;
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,8);
			$fix='8';
			$clienID='180';
			$virtual_accout=$fix.$clienID.$result['id_city_komisariat'].$angka_urut_va;
			$expired_unit=date('Y-m-d',strtotime(date("Y-m-d", mktime()) . " + 365 day"));
			$param_virtual_acount=array($this->arr_params['user_id'], $result['nama_lengkap'], $result['email'],$result['no_hp'], $virtual_accout, $expired_unit, $this->arr_params['user_id']);
			//print_r($param_virtual_acount);exit;
			// execute process
			//$this->obj_registrasi->debugQuery("InsertVirtualAcount",$param_virtual_acount);exit;
			if($this->obj_registrasi->MemberVirtualAcount($param_virtual_acount)){
				// BNI Create VA BNIHashing
					$client_id = '180';
					$secret_key = '99e85c515e571a11a6368fd7ed8e5a53';
					$url = 'https://apibeta.bni-ecollection.com/';
					
					
					$data_asli = array(
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 8 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama_lengkap'],
						'customer_email' => $result['email'],
						'customer_phone' => $result['no_hp']
					);
					
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					
					if ($response_json['status'] !== '000') {
						// handling jika gagal
						var_dump($response_json);
					}
					else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						
						var_dump($data_response);
					}
				// batas Va BNI 
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'form');
	}	
	
	private function UpdateTempatKerja(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		$this->arr_params['berkas'] = $_FILES['berkas'];
		if(empty($this->arr_params['id_job'])){ $err[] = '<br /><strong>Id</strong> tidak terpilih'; }
		//if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> harus diisi'; }
		if(empty($this->arr_params['jabatan'])){ $err[] = '<br /><strong>Jabatan</strong> harus diisi'; }
		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }
		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));
		if(empty($kota)){ $err[] = '<br /><strong>Kota</strong> harus diisi'; }
		// processing -----------------------------------------------------
		
		if(empty($err)){
			$params = array($this->arr_params['tempat'], $kota, $this->arr_params['nomor_sk'], $this->arr_params['keterangan_sk'], $this->arr_params['jabatan'], $this->arr_params['alamat'], $this->arr_params['telepon'], $this->str_userid, $this->arr_params['id_job'], $this->str_userid);
			print_r($params);exit;
			// execute process
			if($this->obj_cv->UpdateTempatKerja($params)){
				// sukses message		
				self::UploadFile();		
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'edit', array($this->arr_params['id_job']));
	}	
	
	

	
	
	private function DeleteTempatKerja(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }
		// processing --------------------------------------------------
		if(empty($err)){
			foreach($this->arr_params['downcheck'] as $id){
				$params = array($id, $this->str_userid);
				if($this->obj_cv->DeleteTempatKerja($params)){
					// notification message			
					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');
					// redirect to success page ------------------------------------
				}
			}				
		}else{
			// error message
			self::SendNotification($err, $filled, 'Business process failure.', 'error');
			// redirect to page error page ------------------------------------		
		}
	}
	
	
	private function get_content($url, $post = '') {
	$usecookie = __DIR__ . "/cookie.txt";
	$header[] = 'Content-Type: application/json';
	$header[] = "Accept-Encoding: gzip, deflate";
	$header[] = "Cache-Control: max-age=0";
	$header[] = "Connection: keep-alive";
	$header[] = "Accept-Language: en-US,en;q=0.8,id;q=0.6";

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_VERBOSE, false);
	// curl_setopt($ch, CURLOPT_NOBODY, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_ENCODING, true);
	curl_setopt($ch, CURLOPT_AUTOREFERER, true);
	curl_setopt($ch, CURLOPT_MAXREDIRS, 5);

	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.120 Safari/537.36");

	if ($post)
	{
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
	}

	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

	$rs = curl_exec($ch);

	if(empty($rs)){
		var_dump($rs, curl_error($ch));
		curl_close($ch);
		return false;
	}
	curl_close($ch);
	return $rs;
	}
	
	
	private  function tambah_nol($angka,$jumlah){	
		   $jumlah_nol = strlen($angka);
		   $angka_nol = $jumlah - $jumlah_nol;
		   $nol = "";
		   for($i=1;$i<=$angka_nol;$i++)
		   {
			  $nol .= '0';
		   }
		   return $nol.$angka;
	}	
}

?>